library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity REG is
  generic (
    tco : time:=0 ps;
    n : natural := 8 );
  port ( din:	in std_logic_vector(n-1 downto 0);
         clk:	in std_logic;
         ld:	in std_logic;
         clr:	in std_logic;
         dout:	out std_logic_vector(n-1 downto 0)
         );
end REG;

architecture behavioral of REG is
begin
  process(din, clk, ld, clr)
  begin
    if (clr='1') then
      dout <= (others => '0') after tco;
    elsif (clk='1' and clk'event) then
      if (ld='1') then
        dout <= din after tco;
      end if;
    end if;
  end process;
end behavioral;

